SystemOrganization addCategory: #MonticelloFileTree!

MCWriter subclass: #MCFileTreeStWriter
	instanceVariableNames: 'stWriter initializers orderedClassNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree'!

!MCFileTreeStWriter class methodsFor: 'accessing' stamp: 'ezra 11/1/2011 17:52'!
readerClass
	^ MCStReader! !

!MCFileTreeStWriter methodsFor: 'initialize-release' stamp: 'ezra 10/26/2011 17:16'!
initialize
	stWriter := (MCStWriter new)
		initializers: (initializers := Set new);
		yourself.
	orderedClassNames := OrderedCollection new! !

!MCFileTreeStWriter methodsFor: 'visiting' stamp: 'ezra 10/26/2011 17:17'!
visitClassDefinition: definition
	orderedClassNames add: definition className.
	self
		writeInDirectoryName: definition className
		fileName: definition className
		visit: [ 
			stWriter writeClassDefinition: definition.
			definition hasClassInstanceVariables
				ifTrue: [ stWriter writeMetaclassDefinition: definition ].
			definition hasComment
				ifTrue: [ stWriter writeClassComment: definition ] ]! !

!MCFileTreeStWriter methodsFor: 'visiting' stamp: 'dkh 1/30/2012 16:30'!
visitClassTraitDefinition: definition
    self flag: #'skippedForNow'! !

!MCFileTreeStWriter methodsFor: 'visiting' stamp: 'ezra 10/26/2011 17:37'!
visitMetaclassDefinition: definition
	self
		writeInDirectoryName: definition className , '_class'
		fileName: definition className
		visit: [ stWriter writeMetaclassDefinition: definition ]! !

!MCFileTreeStWriter methodsFor: 'visiting' stamp: 'ezra 10/26/2011 16:01'!
visitMethodDefinition: definition
	self
		writeInDirectoryName:
			(definition actualClass isMeta
				ifTrue: [ definition className , '_class' ]
				ifFalse: [ definition className ])
		fileName:
			(definition selector == #/
				ifTrue: [ 'encoded slash' ]
				ifFalse: [ definition selector ])
		visit: [ stWriter visitMethodDefinition: definition ]! !

!MCFileTreeStWriter methodsFor: 'visiting' stamp: 'OttoBehrens 10/25/2011 12:55'!
visitOrganizationDefinition: defintion
	self
		writeInDirectoryName: '.'
		fileName: 'categories'
		visit: [ defintion categories do: [ :cat | stWriter writeCategory: cat ] ]! !

!MCFileTreeStWriter methodsFor: 'visiting' stamp: 'dkh 1/30/2012 16:30'!
visitScriptDefinition: definition
    self flag: #'skippedForNow'! !

!MCFileTreeStWriter methodsFor: 'visiting' stamp: 'dkh 1/30/2012 16:31'!
visitTraitDefinition: definition
    self flag: #'skippedForNow'! !

!MCFileTreeStWriter methodsFor: 'initialize-release' stamp: 'ezra 5/13/2005 15:15'!
writeDefinitions: aCollection
	"the correct initialization order is unknown if some classes are missing in the image"

	[ 
	stWriter acceptVisitor: self forDefinitions: aCollection.
	self writeInitializers ] on: Error do: [ :ex | ex halt ]! !

!MCFileTreeStWriter methodsFor: 'visiting' stamp: 'ezra 10/25/2011 17:49'!
writeInDirectoryName: directoryName fileName: fileName visit: visitBlock
	(directoryName = '.'
		ifTrue: [ stream packageFileDirectory ]
		ifFalse: [ stream subPackageFileDirectoryFor: directoryName ])
		forceNewFileNamed: fileName
		do: [ :file | 
			file lineEndConvention: #lf.
			stWriter stream: file.
			visitBlock value ]! !

!MCFileTreeStWriter methodsFor: 'initialize-release' stamp: 'ezra 10/26/2011 17:43'!
writeInitializers
	self
		writeInDirectoryName: '.'
		fileName: 'initializers'
		visit: [ 
			stWriter
				writePresentInitializers;
				writeAbsentInitializers ]! !

!DirectoryEntryFile methodsFor: '*monticellofiletree' stamp: 'ezra 11/1/2011 17:55'!
readStreamDo: aBlock
	^ directory readOnlyFileNamed: self name do: aBlock! !

MCMczWriter subclass: #MCFileTreeWriter
	instanceVariableNames: 'directory packageFileDirectory cachedPackageFileDirectoryEntries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree'!

!MCFileTreeWriter class methodsFor: 'accessing' stamp: 'OttoBehrens 10/24/2011 20:35'!
readerClass
	^ MCFileTreeReader! !

!MCFileTreeWriter methodsFor: 'writing' stamp: 'ezra 10/25/2011 16:22'!
addString: string at: path
	string isEmpty
		ifFalse: [ 
			| fullPath |
			fullPath := self packageFileDirectory fullNameFor: path.
			FileStream forceNewFileNamed: fullPath do: [ :file | file nextPutAll: string ] ]! !

!MCFileTreeWriter methodsFor: 'writing' stamp: 'OttoBehrens 10/24/2011 21:34'!
flush
	! !

!MCFileTreeWriter methodsFor: 'visiting' stamp: 'ezra 10/25/2011 16:53'!
initializePackageFileDirectoryCache
	cachedPackageFileDirectoryEntries := Dictionary new.
	self packageFileDirectory entries
		do: [ :entry | 
			entry isDirectory
				ifTrue: [ cachedPackageFileDirectoryEntries at: entry name put: entry asFileDirectory ] ]! !

!MCFileTreeWriter methodsFor: 'writing' stamp: 'ezra 10/25/2011 17:10'!
packageFileDirectory
	^ packageFileDirectory := stream directory directoryNamed: directory! !

!MCFileTreeWriter methodsFor: 'accessing' stamp: 'OttoBehrens 10/24/2011 20:40'!
snapshotWriterClass
	^ MCFileTreeStWriter! !

!MCFileTreeWriter methodsFor: 'visiting' stamp: 'ezra 10/25/2011 17:29'!
subPackageFileDirectoryFor: directoryName
	^ cachedPackageFileDirectoryEntries
		at: directoryName
		ifAbsentPut: [ 
			(self packageFileDirectory)
				createDirectory: directoryName;
				directoryNamed: directoryName ]! !

!MCFileTreeWriter methodsFor: 'visiting' stamp: 'OttoBehrens 10/25/2011 10:15'!
writeSnapshot: aSnapshot
	(self snapshotWriterClass on: self) writeDefinitions: aSnapshot definitions! !

!MCFileTreeWriter methodsFor: 'visiting' stamp: 'ezra 10/28/2011 19:07'!
writeVersion: aVersion
	directory := aVersion package name , '.tree'.
	self packageFileDirectory exists
		ifTrue: [ self packageFileDirectory recursiveDelete ].
	self packageFileDirectory assureExistence.
	self initializePackageFileDirectoryCache.
	super writeVersion: aVersion! !

MCDirectoryRepository subclass: #MCFileTreeRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree'!

!MCFileTreeRepository class methodsFor: 'instance creation' stamp: 'OttoBehrens 10/24/2011 22:25'!
description
	^ 'file tree'! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'ezra 10/28/2011 19:24'!
allFileNames
	^(directory entries select: [:entry | entry isDirectory and: [self canReadFileNamed: entry name]]) collect: [:entry | entry name]! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'ezra 10/28/2011 18:41'!
allFileNamesForVersionNamed: aString
	^ {(self treeDirectoryNameForVersionNamed: aString)}! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'OttoBehrens 10/25/2011 07:21'!
basicStoreVersion: aVersion
	MCFileTreeWriter fileOut: aVersion on: self! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'OttoBehrens 10/25/2011 07:20'!
cachedFileNames
	^ #()! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'ezra 10/28/2011 19:24'!
canReadFileNamed: aString
	^aString endsWith: '.tree'! !

!MCFileTreeRepository methodsFor: 'descriptions' stamp: 'dkh 1/30/2012 13:56'!
description
    ^ 'filetree://' , super description! !

!MCFileTreeRepository methodsFor: 'actions' stamp: 'OttoBehrens 10/25/2011 08:57'!
fileDirectoryOn: fileName
	^ FileDirectory on: (directory fullNameFor: fileName)! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'ezra 10/28/2011 18:46'!
goferVersionFrom: aVersionReference
	^ self loadVersionFromFileNamed: (self treeDirectoryNameForVersionNamed: aVersionReference name)! !

!MCFileTreeRepository methodsFor: 'actions' stamp: 'ezra 10/28/2011 18:32'!
packageDescriptionFromPackageDirectory: packageDirectory
	| info packageName |
	info := self versionInfoForPackageDirectory: packageDirectory.
	packageName := info name copyUpToLast: $-.
	^ {packageName.
	(info author).
	(info versionNumber).
	(packageName , '.tree')}! !

!MCFileTreeRepository methodsFor: 'actions' stamp: 'ezra 10/28/2011 18:32'!
packageDescriptionsFromReadableFileNames
	^ ((self readableFileNames collect: [ :fileName | self fileDirectoryOn: fileName ])
		select: [ :packageDirectory | packageDirectory exists ])
		collect: [ :packageDirectory | self packageDescriptionFromPackageDirectory: packageDirectory ]! !

!MCFileTreeRepository methodsFor: 'i/o' stamp: 'ezra 10/28/2011 18:53'!
readStreamForFileNamed: aString do: aBlock
	^ aBlock value: directory! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'ezra 10/28/2011 18:41'!
treeDirectoryNameForVersionNamed: aString
	^ (aString copyUpToLast: $-) , '.tree'! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'OttoBehrens 10/25/2011 07:20'!
versionFromFileNamed: aString
	^ self loadVersionFromFileNamed: aString! !

!MCFileTreeRepository methodsFor: 'actions' stamp: 'OttoBehrens 10/25/2011 09:00'!
versionInfoForPackageDirectory: packageDirectory
	^ (MCFileTreeReader on: packageDirectory containingDirectory fileName: packageDirectory localName)
		loadVersionInfo;
		info! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'OttoBehrens 10/25/2011 07:22'!
versionInfoFromFileNamed: aString
	^ self loadVersionInfoFromFileNamed: aString! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'ezra 10/28/2011 18:36'!
versionNameFromFileName: aString
	| description |
	description := self packageDescriptionFromPackageDirectory: (self fileDirectoryOn: aString).
	^ description first , '-' , description second , '.' , description third printString! !

!MCFileTreeRepository methodsFor: 'interface' stamp: 'OttoBehrens 10/26/2011 20:13'!
versionWithInfo: aVersionInfo ifAbsent: errorBlock
	(self allFileNamesForVersionNamed: aVersionInfo name)
		ifNotEmpty: [ :aCollection | ^ self versionFromFileNamed: aCollection first ].
	^ errorBlock value! !

!MCFileTreeRepository methodsFor: 'i/o' stamp: 'OttoBehrens 10/26/2011 20:45'!
writeStreamForFileNamed: aString replace: aBoolean do: aBlock
	self error: 'we do not open a single stream, but write multiple files'! !

!MCFileRepositoryInspector methodsFor: '*monticellofiletree' stamp: 'OttoBehrens 10/24/2011 23:31'!
refresh
	| packageNames |
	packageNames := Set new.
	packageList := nil.
	versions := repository retrieveVersionsWithPackageNames: packageNames.
	newer := Set new.
	inherited := Set new.
	loaded := Set new.
	MCWorkingCopy allManagers
		do: [ :each | 
			| latest |
			each ancestors
				do: [ :ancestor | 
					loaded add: ancestor name.
					ancestor
						ancestorsDoWhileTrue: [ :heir | 
							(inherited includes: heir name)
								ifTrue: [ false ]
								ifFalse: [ 
									inherited add: heir name.
									true ] ] ].
			latest := (versions select: [ :v | v first = each package name ]) detectMax: [ :v | v third ].
			(latest notNil
				and: [ 
					each ancestors
						allSatisfy: [ :ancestor | 
							| av |
							av := ((ancestor name copyAfterLast: $-) copyAfter: $.) asInteger.
							av < latest third
								or: [ av = latest third and: [ ((ancestor name copyAfterLast: $-) copyUpTo: $.) ~= latest second ] ] ] ])
				ifTrue: [ newer add: each package name ] ].	"		select: [ :each | packageNames includes: each packageName]"
	self
		changed: #packageList;
		changed: #versionList! !

MCMczReader subclass: #MCFileTreeReader
	instanceVariableNames: 'packageDirectory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree'!

!MCFileTreeReader class methodsFor: 'accessing' stamp: 'OttoBehrens 10/24/2011 22:49'!
extension
	^ 'tree'! !

!MCFileTreeReader class methodsFor: 'reading' stamp: 'OttoBehrens 10/25/2011 00:58'!
on: s fileName: f
	^ (self on: s)
		packageDirectory: f;
		yourself! !

!MCFileTreeReader methodsFor: 'utilities' stamp: 'ezra 11/1/2011 14:41'!
addClassAndMethodDefinitionsFromDirectoryEntries: entries 
	entries
		do: [:entry | entry isDirectory
				ifTrue: [entry asFileDirectory entries
						do: [:file | self addDefinitionFromFile: file]]]! !

!MCFileTreeReader methodsFor: 'utilities' stamp: 'ezra 11/1/2011 17:57'!
addDefinitionFromFile: directoryEntry
	| defs reader |
	directoryEntry ifNil: [ ^ #() ].
	directoryEntry
		readStreamDo: [ :fileStream | 
			reader := MCStReader on: fileStream.
			(defs := reader definitions) size <= 1
				ifFalse: [ 'we are attempting to write exactly 1 definition per file' halt ] ].
	^ definitions addAll: defs
	! !

!MCFileTreeReader methodsFor: 'accessing' stamp: 'OttoBehrens 10/25/2011 09:31'!
basicVersion
	^ (MCVersion new)
		setPackage: self package
			info: self info
			snapshot: self snapshot
			dependencies: self dependencies;
		yourself! !

!MCFileTreeReader methodsFor: 'utilities' stamp: 'ezra 11/1/2011 17:25'!
loadDefinitions
	| entries |
	definitions := OrderedCollection new.
	entries := packageDirectory entries.
	[ 
	self
		addDefinitionFromFile: (entries detect: [ :entry | entry name = 'categories' ] ifNone: [  ]);
		addClassAndMethodDefinitionsFromDirectoryEntries: entries;
		addDefinitionFromFile: (entries detect: [ :entry | entry name = 'initializers' ] ifNone: [  ]) ]
		on: Error
		do: [ :error | error halt ]! !

!MCFileTreeReader methodsFor: 'utilities' stamp: 'OttoBehrens 10/25/2011 01:31'!
loadDependencies
	dependencies := Array new! !

!MCFileTreeReader methodsFor: 'accessing' stamp: 'OttoBehrens 10/25/2011 01:29'!
packageDirectory: aByteString
	packageDirectory := (stream entryAt: aByteString) asFileDirectory! !

!MCFileTreeReader methodsFor: 'utilities' stamp: 'OttoBehrens 10/25/2011 01:21'!
parseMember: fileName
	| tokens contents |
	contents := packageDirectory fileNamed: fileName do: [ :file | file contents ].
	tokens := (self scanner scanTokens: contents) first.
	^ self associate: tokens! !

!MCMczReader methodsFor: '*monticellofiletree' stamp: 'OttoBehrens 10/25/2011 01:11'!
extractDefinitionsFrom: member
	self extractDefinitionsFromFile: member contentStream named: member fileName! !

!MCMczReader methodsFor: '*monticellofiletree' stamp: 'OttoBehrens 10/25/2011 01:12'!
extractDefinitionsFromFile: file named: fileName
	(MCSnapshotReader readerClassForFileNamed: fileName)
		ifNotNil: [ :rc | 
			| reader |
			reader := rc on: file text.
			definitions addAll: reader definitions ]! !

!MCStWriter methodsFor: '*monticellofiletree' stamp: 'ezra 10/26/2011 17:25'!
absentInitializers
	^ initializers reject: [ :each | Smalltalk hasClassNamed: each key ]! !

!MCStWriter methodsFor: '*monticellofiletree' stamp: 'ezra 10/26/2011 17:33'!
acceptVisitor: aVisitor forDefinitions: aCollection
	(MCDependencySorter sortItems: aCollection)
		do: [ :ea | ea accept: aVisitor ]
		displayingProgress: 'Writing definitions...'! !

!MCStWriter methodsFor: '*monticellofiletree' stamp: 'OttoBehrens 10/25/2011 11:05'!
initializers: aCollection
	initializers := aCollection! !

!MCStWriter methodsFor: '*monticellofiletree' stamp: 'ezra 10/26/2011 17:19'!
presentInitializers
	^ initializers select: [ :each | Smalltalk hasClassNamed: each key ]! !

!MCStWriter methodsFor: '*monticellofiletree' stamp: 'ezra 10/26/2011 17:25'!
writeAbsentInitializers
	(self absentInitializers asSortedCollection: [ :a :b | a key <= b key ])
		do: [ :association | stream nextPutAll: association value contents ]! !

!MCStWriter methodsFor: '*monticellofiletree' stamp: 'ezra 10/25/2011 16:05'!
writeClassDefinition: definition
	self chunkContents: [ :s | definition printDefinitionOn: s ]! !

!MCStWriter methodsFor: '*monticellofiletree' stamp: 'ezra 10/26/2011 17:35'!
writeDefinitions: aCollection
	"the correct initialization order is unknown if some classes are missing in the image"

	initializers := Set new.
	self
		acceptVisitor: self forDefinitions: aCollection;
		writePresentInitializers;
		writeAbsentInitializers! !

!MCStWriter methodsFor: '*monticellofiletree' stamp: 'ezra 10/26/2011 17:21'!
writePresentInitializers
	| orderedClasses presentInitializers |
	presentInitializers := self presentInitializers.
	orderedClasses := (Class
		superclassOrder: (presentInitializers collect: [ :each | Smalltalk classOrTraitNamed: each key ]))
		collect: [ :each | each name ].
	orderedClasses
		do: [ :className | stream nextPutAll: (presentInitializers detect: [ :each | each key = className ]) value contents ]! !

!MCVersionInfo methodsFor: '*monticellofiletree' stamp: 'OttoBehrens 10/25/2011 08:59'!
versionNumber
	^ ((self name copyAfterLast: $-) copyAfter: $.) asInteger ifNil: [ 0 ]! !

!MCFileBasedRepository methodsFor: '*monticellofiletree' stamp: 'ezra 10/28/2011 18:25'!
packageDescriptionsFromReadableFileNames
	^ self readableFileNames
		collect: [ :each | 
			| name |
			name := (each copyUpToLast: $.) copyUpTo: $(.
			name last isDigit
				ifFalse: [ 
					{name.
					''.
					''.
					each} ]
				ifTrue: [ 
					| packageName author versionNumber |
					packageName := name copyUpToLast: $-.
					author := (name copyAfterLast: $-) copyUpTo: $..
					versionNumber := ((name copyAfterLast: $-) copyAfter: $.) asInteger ifNil: [ 0 ].
					{packageName.
					author.
					versionNumber.
					each} ] ]! !

!MCFileBasedRepository methodsFor: '*monticellofiletree' stamp: 'ezra 10/28/2011 18:25'!
retrieveVersionsWithPackageNames: packageNames
	| packageDescriptions |
	packageDescriptions := self packageDescriptionsFromReadableFileNames.
	packageNames addAll: (packageDescriptions collect: [ :packageDescription | packageDescription first ]).
	^ packageDescriptions select: [ :each | (each at: 3) isNumber ]! !
